package tc65Test;

import com.siemens.icm.io.ATCommand;
import com.siemens.icm.io.ATCommandFailedException;

public class Tc65Io {
	ATCommand		atCommand;
	Tc65SerialPort tc65SerialPort;
	
	public Tc65Io(ATCommand atCommand, Tc65SerialPort tc65SerialPort)
	{
		this.atCommand = atCommand;

		this.tc65SerialPort = tc65SerialPort; //for debug

	}

	/**
	 *   -
	 *
	 */
	public boolean initIo()
	{
		boolean bRet = true;
		
		try
		{
			atCommand.send("AT^SPIO=0\r"); //   I/O
			Thread.sleep(200);
			atCommand.send("AT^SPIO=1\r"); //   I/O
			Thread.sleep(200);
			atCommand.send("AT^SCPIN=1,0,1,0\r"); // . GPIO1, out, init_state=0 
			Thread.sleep(200);
		}
		catch(ATCommandFailedException e)
		{
			tc65SerialPort.serialOut("ERROR: I/O init failed\n\r");
			bRet = false;
		}
		catch(InterruptedException e)
		{
			tc65SerialPort.serialOut("ERROR: I/O init failed\n\r");
			bRet = false;
		}
		return bRet;
	}
	
	public void closeIo()
	{
		try
		{
			atCommand.send("AT^SPIO=0\r"); //   I/O
			Thread.sleep(200);
		}
		catch(ATCommandFailedException e)
		{
			tc65SerialPort.serialOut("ERROR: I/O cleanup failed\n\r");
		}
		catch(InterruptedException e)
		{
			tc65SerialPort.serialOut("ERROR: I/O cleanup failed\n\r");
		}
	}
}
